From: Doug Kelly <dougk.ff7@gmail.com>
To: git@vger.kernel.org
Cc: Doug Kelly <dougk.ff7@gmail.com>
Subject: [PATCH 1/2] t4255: test am submodule with diff.submodule
Date: Fri, 26 Dec 2014 17:11:45 -0600 [thread overview]
Message-ID: <1419635506-5045-2-git-send-email-dougk.ff7@gmail.com> (raw)
In-Reply-To: <1419635506-5045-1-git-send-email-dougk.ff7@gmail.com>
git am will break when using diff.submodule=log; add some test cases
to illustrate this breakage as simply as possible. There are
currently two ways this can fail:
* With errors ("unrecognized input"), if only change
* Silently (no submodule change), if other files change
Test for both conditions and ensure without diff.submodule this works.
Signed-off-by: Doug Kelly <dougk.ff7@gmail.com>
---
t/t4255-am-submodule.sh | 83 +++++++++++++++++++++++++++++++++++++++++++++++++
1 file changed, 83 insertions(+)
diff --git a/t/t4255-am-submodule.sh b/t/t4255-am-submodule.sh
index 8bde7db..d9a1d79 100755
--- a/t/t4255-am-submodule.sh
+++ b/t/t4255-am-submodule.sh
@@ -18,4 +18,87 @@ am_3way () {
KNOWN_FAILURE_NOFF_MERGE_ATTEMPTS_TO_MERGE_REMOVED_SUBMODULE_FILES=1
test_submodule_switch "am_3way"
+test_expect_success 'setup diff.submodule' '
+ echo one >one &&
+ git add one &&
+ test_tick &&
+ git commit -m initial &&
+ git rev-parse HEAD >initial &&
+
+ git init submodule &&
+ (cd submodule &&
+ echo two >two &&
+ git add two &&
+ test_tick &&
+ git commit -m "initial submodule" &&
+ git rev-parse HEAD >../initial-submodule) &&
+ git submodule add ./submodule &&
+ test_tick &&
+ git commit -m first &&
+ git rev-parse HEAD >first &&
+
+ (cd submodule &&
+ echo three >three &&
+ git add three &&
+ test_tick &&
+ git commit -m "first submodule" &&
+ git rev-parse HEAD >../first-submodule) &&
+ git add submodule &&
+ test_tick &&
+ git commit -m second &&
+ git rev-parse HEAD >second &&
+
+ (cd submodule &&
+ git mv two four &&
+ test_tick &&
+ git commit -m "second submodule" &&
+ git rev-parse HEAD >../second-submodule) &&
+ git add submodule &&
+ echo four >four &&
+ git add four &&
+ test_tick &&
+ git commit -m third &&
+ git rev-parse HEAD >third &&
+ git submodule update --init
+'
+
+INITIAL=$(cat initial)
+SECOND=$(cat second)
+THIRD=$(cat third)
+
+run_test() {
+ START_COMMIT=$1
+ EXPECT=$2
+ (git am --abort || true) &&
+ git reset --hard $START_COMMIT &&
+ rm -f *.patch &&
+ git format-patch -1 &&
+ git reset --hard $START_COMMIT^ &&
+ git submodule update &&
+ git am *.patch &&
+ git submodule update &&
+ (cd submodule && git rev-parse HEAD >../actual) &&
+ test_cmp $EXPECT actual
+}
+
+test_expect_success 'diff.submodule unset' '
+ (git config --unset diff.submodule || true) &&
+ run_test $SECOND 'first-submodule'
+'
+
+test_expect_success 'diff.submodule unset with extra file' '
+ (git config --unset diff.submodule || true) &&
+ run_test $THIRD 'second-submodule'
+'
+
+test_expect_success 'diff.submodule=log' '
+ git config diff.submodule log &&
+ run_test $SECOND 'first-submodule'
+'
+
+test_expect_success 'diff.submodule=log with extra file' '
+ git config diff.submodule log &&
+ run_test $THIRD 'second-submodule'
+'
+
test_done
--
2.0.5
next prev parent reply other threads:[~2014-12-26 23:12 UTC|newest]
Thread overview: 18+ messages / expand[flat|nested] mbox.gz Atom feed top
2014-12-26 23:11 [PATCH 0/2] Fix issue with format-patch and diff.submodule Doug Kelly
2014-12-26 23:11 ` Doug Kelly [this message]
2014-12-28 0:37 ` [PATCH 1/2] t4255: test am submodule with diff.submodule Eric Sunshine
2014-12-28 1:00 ` Doug Kelly
2014-12-29 15:42 ` Junio C Hamano
2015-01-07 19:34 ` Doug Kelly
2015-01-07 20:20 ` Junio C Hamano
2014-12-26 23:11 ` [PATCH 2/2] format-patch: ignore diff.submodule setting Doug Kelly
2014-12-28 1:04 ` [PATCH v2 1/2] t4255: test am submodule with diff.submodule Doug Kelly
2014-12-28 1:04 ` [PATCH v2 2/2] format-patch: ignore diff.submodule setting Doug Kelly
2014-12-28 2:24 ` [PATCH v2 1/2] t4255: test am submodule with diff.submodule Eric Sunshine
2015-01-07 19:31 ` [PATCH v3 " Doug Kelly
2015-01-07 19:31 ` [PATCH v3 2/2] format-patch: ignore diff.submodule setting Doug Kelly
2015-01-07 20:06 ` [PATCH v3 1/2] t4255: test am submodule with diff.submodule Eric Sunshine
2015-01-07 20:13 ` [PATCH v4 " Doug Kelly
2015-01-07 20:13 ` [PATCH v4 2/2] format-patch: ignore diff.submodule setting Doug Kelly
2015-01-07 20:32 ` [PATCH v5 1/2] t4255: test am submodule with diff.submodule Doug Kelly
2015-01-07 20:32 ` [PATCH v5 2/2] format-patch: ignore diff.submodule setting Doug Kelly
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=1419635506-5045-2-git-send-email-dougk.ff7@gmail.com \
--to=dougk.ff7@gmail.com \
--cc=git@vger.kernel.org \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.